// Generated by StrataCode from sc/bind/Bind.sc layer: fullRuntime
//   merging: sc/bind/Bind.java layer: coreRuntime
/** Modify the jarPackages required for the full runtime.  Modifies the Bind class in the coreRuntime and adds a few packages that go into the full runtime jar. */
package sc.bind;
import sc.type.TypeUtil;
import sc.type.PTypeUtil;
import sc.type.IBeanMapper;
import sc.sync.SyncManager;
import sc.obj.ScopeDefinition;
import sc.obj.ScopeContext;
import sc.obj.CurrentScopeContext;
import sc.obj.CompilerSettings;
import sc.js.JSSettings;
import sc.dyn.DynUtil;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
@CompilerSettings(jarFileName = "bin/scrt.jar", srcJarFileName = "bin/scrt-src.jar", jarPackages = { "sc.type", "sc.bind", "sc.obj", "sc.dyn", "sc.js", "sc.util"})
   @JSSettings(jsLibFiles = "js/sccore.js,js/scdyn.js,js/scbind.js", prefixAlias = "sc_")
public class Bind {
   public static int INACTIVE = 1, TRACE = 2, VERBOSE = 4, QUEUED = 8, IMMEDIATE = 16, CROSS_SCOPE = 32, DO_LATER = 64, HISTORY = 128, ORIGIN = 256, SKIP_NULL = 512;
   static int PROPAGATED_FLAGS = SKIP_NULL;
   public static void removeListenerOfType(Object inst, IBeanMapper prop, Object listenerType, int valueChangedMask) {
      BindingListener listenerPtr = getPropListeners(inst, prop);
      while (listenerPtr != null) {
         IListener toRemListener = listenerPtr.listener;
         Object curListenerType = DynUtil.getType(toRemListener);
         if (curListenerType == listenerType) {
            removeListener(inst, prop, toRemListener, valueChangedMask);
            return;
         }
         listenerPtr = listenerPtr.next;
      }
      System.err.println("*** Failed to remove listener of type: " + listenerType + " for property: " + prop.getPropertyName() + " on object: " + inst);
   }
   static class BindingListenerEntry {
      int numProps = 0;
      BindingListener[] bindingListeners;
      public String toString() {
         return arrayToString(bindingListeners);
      }
   }
   public final static Map<Object, List<DestinationListener>> bindingContainerRegistry = PTypeUtil.getWeakIdentityHashMap();
   public final static Map<Object, BindingListenerEntry> bindingListenerRegistry = PTypeUtil.getWeakIdentityHashMap();
   public static boolean trace = false;
   public static boolean traceAll = false;
   public static boolean info = true;
   public static BindingManager bindingManager = new BindingManager();
   public static Object bind(Object dstObj, String dstProp, Object srcObj, Object[] boundProps, BindingDirection dir, int flags, BindOptions opts) {
      return bind(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), srcObj,
                 boundProps, dir, flags, opts);
   }
   public static Object bind(Object dstObj, IBinding dstProp, Object srcObj, Object[] boundProps, BindingDirection dir, int flags, BindOptions opts) {
      VariableBinding binding = new VariableBinding(dstObj, dstProp, srcObj, boundProps, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static int bindInt(Object dstObj, IBinding dstProp, Object srcObj, Object[] boundProps, BindingDirection dir, int flags, BindOptions opts) {
      VariableBinding binding = new VariableBinding(dstObj, dstProp, srcObj, boundProps, dir, flags, opts);
      Object val = bindInternal(dstObj, binding);
      if (val == null)
         return 0;
      return((Number) val).intValue();
   }
   public static Object method(Object dstObj, String dstProp, Object method, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return method(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), method,
                 boundArgs, dir, flags, opts);
   }
   public static Object method(Object dstObj, IBinding dstProp, Object method, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      MethodBinding binding = new MethodBinding(dstObj, dstProp, dstObj, method, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object method(Object dstObj, String dstProp, Object methObj, Object method, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return method(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), methObj,
                 method, boundArgs, dir, flags, opts);
   }
   public static Object method(Object dstObj, IBinding dstProp, Object methObj, Object method, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      MethodBinding binding = new MethodBinding(dstObj, dstProp, methObj, method, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object arith(Object dstObj, String dstProp, String operator, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return arith(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), operator,
                 boundArgs, dir, flags, opts);
   }
   public static Object arith(Object dstObj, IBinding dstProp, String operator, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      ArithmeticBinding binding = new ArithmeticBinding(dstObj, dstProp, operator, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object condition(Object dstObj, String dstProp, String operator, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return condition(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), operator,
                 boundArgs, dir, flags, opts);
   }
   public static Object condition(Object dstObj, IBinding dstProp, String operator, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      ConditionalBinding binding = new ConditionalBinding(dstObj, dstProp, operator, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object unary(Object dstObj, String dstProp, String operator, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return unary(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), operator,
                 boundArgs, dir, flags, opts);
   }
   public static Object unary(Object dstObj, IBinding dstProp, String operator, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      UnaryBinding binding = new UnaryBinding(dstObj, dstProp, operator, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object ternary(Object dstObj, String dstProp, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return ternary(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), boundArgs,
                 dir, flags, opts);
   }
   public static Object ternary(Object dstObj, IBinding dstProp, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      TernaryBinding binding = new TernaryBinding(dstObj, dstProp, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object arrayElement(Object dstObj, String dstProp, Object srcObj, Object[] boundArgs, IBinding[] arrayDims, BindingDirection dir, int flags, BindOptions opts) {
      return arrayElement(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), srcObj,
                 boundArgs, arrayDims, dir, flags, opts);
   }
   public static Object arrayElement(Object dstObj, IBinding dstProp, Object srcObj, Object[] args, IBinding[] arrayDims, BindingDirection dir, int flags, BindOptions opts) {
      ArrayElementBinding binding = new ArrayElementBinding(dstObj, dstProp, srcObj, args, arrayDims, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object cast(Object dstObj, String dstProp, Class theClass, IBinding boundArg, BindingDirection dir, int flags, BindOptions opts) {
      return cast(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), theClass,
                 boundArg, dir, flags, opts);
   }
   public static Object cast(Object dstObj, IBinding dstProp, Class theClass, IBinding arg, BindingDirection dir, int flags, BindOptions opts) {
      CastBinding binding = new CastBinding(dstObj, dstProp, theClass, arg, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object selector(Object dstObj, String dstProp, Object[] boundProps, BindingDirection dir, int flags, BindOptions opts) {
      return selector(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), boundProps,
                 dir, flags, opts);
   }
   public static Object selector(Object dstObj, IBinding dstProp, Object[] boundProps, BindingDirection dir, int flags, BindOptions opts) {
      SelectorBinding binding = new SelectorBinding(dstObj, dstProp, boundProps, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object bindNew(Object dstObj, String dstProp, Object newType, String paramSig, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return bindNew(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), newType,
                 paramSig, boundArgs, dir, flags, opts);
   }
   public static Object bindNew(Object dstObj, IBinding dstProp, Object newType, String paramSig, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      NewBinding binding = new NewBinding(dstObj, dstProp, newType, paramSig, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object newArray(Object dstObj, String dstProp, Object compType, IBinding[] boundArgs, BindingDirection dir, int flags, BindOptions opts) {
      return newArray(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), compType,
                 boundArgs, dir, flags, opts);
   }
   public static Object newArray(Object dstObj, IBinding dstProp, Object compType, IBinding[] args, BindingDirection dir, int flags, BindOptions opts) {
      NewArrayBinding binding = new NewArrayBinding(dstObj, dstProp, compType, args, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object assign(Object dstObj, String dstProp, Object srcObj, IBinding lhsBinding, Object rhs, BindingDirection dir, int flags, BindOptions opts) {
      return assign(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), srcObj,
                 lhsBinding, rhs, dir, flags, opts);
   }
   public static Object assign(Object dstObj, IBinding dstProp, Object srcObj, IBinding lhsBinding, Object rhs, BindingDirection dir, int flags, BindOptions opts) {
      AssignmentBinding binding = rhs instanceof IBinding ? new AssignmentBinding(dstObj, dstProp, srcObj, (VariableBinding) lhsBinding, (IBinding) rhs, dir,
                    flags, opts) : new AssignmentBinding(dstObj, dstProp, srcObj, (VariableBinding) lhsBinding, rhs, dir, flags, opts);
      return bindInternal(dstObj, binding);
   }
   public static Object constant(Object dstObj, String dstProp, Object value, BindingDirection dir, int flags, BindOptions opts) {
      return constant(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, dstProp), value, dir,
                 flags, opts);
   }
   public static Object constant(Object dstObj, IBinding dstProp, Object value, BindingDirection dir, int flags, BindOptions opts) {
      if (dir.doForward())
         removePropertyBindings(dstObj, dstProp, true, false);
      return value;
   }
   private static DestinationListener bindToList(List<DestinationListener> bindings, DestinationListener binding, Object dstObj) {
      int sz = bindings.size();
      int i;
      DestinationListener replacedBinding = null;
      if (binding.direction.doForward()) {
         for (i = 0; i < sz; i++) {
            DestinationListener oldBinding = bindings.get(i);
            if (PBindUtil.equalProps(oldBinding.dstProp, binding.dstProp) && oldBinding.direction.doForward()) {
               replacedBinding = oldBinding;
               oldBinding.removeListener();
               bindings.set(i, binding);
               break;
            }
         }
         if (i == sz)
            bindings.add(binding);
      }
      else
         bindings.add(binding);
      return replacedBinding;
   }
   public static int removePropertyBindings(Object dstObj, String propName, boolean removeForward, boolean removeReverse) {
      return removePropertyBindings(dstObj, TypeUtil.resolveObjectPropertyMapping(dstObj, propName),
                 removeForward, removeReverse);
   }
   public static int removePropertyBindings(Object dstObj, IBinding dstProp, boolean removeForward, boolean removeReverse) {
      List<DestinationListener> bindings;
      if (dstObj instanceof IBindingContainer) {
         IBindingContainer bc = (IBindingContainer) dstObj;
         bindings = bc.getBindings();
         if (bindings == null) {
            return 0;
         }
      }
      else {
         synchronized(bindingContainerRegistry) {
            bindings = bindingContainerRegistry.get(dstObj);
            if (bindings == null) {
               return 0;
            }
         }
      }
      int sz = bindings.size();
      int ct = 0;
      for (int i = 0; i < sz; i++) {
         DestinationListener oldBinding = bindings.get(i);
         if (PBindUtil.equalProps(oldBinding.dstProp, dstProp) && ((removeForward && oldBinding.direction.doForward()) || (removeReverse && oldBinding.direction.doReverse()))) {
            oldBinding.removeListener();
            bindings.remove(i);
            ct++;
            i--;
            sz--;
         }
      }
      return ct;
   }
   private static Object bindInternal(Object dstObj, DestinationListener binding) {
      DestinationListener oldBinding;
      if (dstObj instanceof IBindingContainer) {
         IBindingContainer bc = (IBindingContainer) dstObj;
         List<DestinationListener> bindings = bc.getBindings();
         if (bindings == null) {
            bindings = new ArrayList<DestinationListener>();
            bc.setBindings(bindings);
         }
         oldBinding = bindToList(bindings, binding, dstObj);
      }
      else {
         synchronized(bindingContainerRegistry) {
            List<DestinationListener> bindings = bindingContainerRegistry.get(dstObj);
            if (bindings == null) {
               bindings = new ArrayList<DestinationListener>();
               bindingContainerRegistry.put(dstObj, bindings);
            }
            oldBinding = bindToList(bindings, binding, dstObj);
         }
      }
      Object res = binding.initializeBinding();
      if (oldBinding != null && (trace || (oldBinding.flags & TRACE) != 0)) {
         if (logBindingMessage("replaced", oldBinding, dstObj, null, binding))
            endPropMessage();
      }
      return res;
   }
   public static IBinding bindP(Object srcObj, Object[] boundProps) {
      if (boundProps.length == 0)
         return new ConstantBinding(srcObj);
      return new VariableBinding(srcObj, boundProps);
   }
   public static IBinding methodP(Object method, IBinding[] boundArgs) {
      return new MethodBinding(method, boundArgs);
   }
   public static IBinding methodP(Object methObj, Object method, IBinding[] boundArgs) {
      return new MethodBinding(methObj, method, boundArgs);
   }
   public static IBinding arithP(String operator, IBinding[] boundArgs) {
      return new ArithmeticBinding(operator, boundArgs);
   }
   public static IBinding conditionP(String operator, IBinding[] boundArgs) {
      return new ConditionalBinding(operator, boundArgs);
   }
   public static IBinding unaryP(String operator, IBinding[] boundArgs) {
      return new UnaryBinding(operator, boundArgs);
   }
   public static IBinding ternaryP(IBinding[] boundArgs) {
      return new TernaryBinding(boundArgs);
   }
   public static IBinding arrayElementP(Object srcObj, Object[] boundArgs, IBinding[] arrayDims) {
      return new ArrayElementBinding(srcObj, boundArgs, arrayDims);
   }
   public static IBinding castP(Class theClass, IBinding boundArg) {
      return new CastBinding(theClass, boundArg);
   }
   public static IBinding selectorP(Object[] boundProps) {
      return new SelectorBinding(boundProps);
   }
   public static IBinding constantP(Object value) {
      return new ConstantBinding(value);
   }
   public static IBinding bindNewP(Object newClass, String paramSig, IBinding[] boundProps) {
      return new NewBinding(newClass, paramSig, boundProps);
   }
   public static IBinding newArrayP(Object newClass, IBinding[] boundProps) {
      return new NewArrayBinding(newClass, boundProps);
   }
   public static IBinding assignP(Object srcObj, IBinding lhsBinding, Object rhsValue) {
      return new AssignmentBinding(srcObj, (VariableBinding) lhsBinding, rhsValue);
   }
   public static void removeBindings(Object dstObj) {
      removeBindings(dstObj, true);
   }
   public static void removeBindings(Object dstObj, boolean removeChildren) {
      List<DestinationListener> bindings;
      if (dstObj instanceof IBindingContainer) {
         IBindingContainer bc = (IBindingContainer) dstObj;
         bindings = bc.getBindings();
         bc.setBindings(null);
      }
      else {
         synchronized(bindingContainerRegistry) {
            bindings = bindingContainerRegistry.remove(dstObj);
         }
      }
      if (bindings == null)
         return;
      if (trace)
         System.out.println("Removing: " + bindings.size() + " bindings for: " + DynUtil.getInstanceName(dstObj));
      for (int i = 0; i < bindings.size(); i++) bindings.get(i).removeListener();
      if (removeChildren) {
         Object[] children = DynUtil.getObjChildren(dstObj, null, false);
         if (children != null) {
            for (Object child : children) {
               if (child != null)
                  removeBindings(child);
            }
         }
      }
   }
   public static int refreshBindings(Object dstObj) {
      boolean endLogIndent = false;
      int ct = 0;
      long startTime = 0;
      if (trace) {
         endLogIndent = logPropMessage("Refresh", dstObj, null, null);
         startTime = System.currentTimeMillis();
      }
      try {
         ct = refreshBindings(dstObj, true);
      }
      finally {
         if (endLogIndent) {
            System.out.println(indent(getIndentLevel()) + "refreshed: " + ct + " in: " + (System.currentTimeMillis() - startTime) + " millis");
            endPropMessage();
         }
      }
      return ct;
   }
   public static int refreshBindings(Object dstObj, boolean refreshChildren) {
      List<DestinationListener> bindings;
      int ct = 0;
      if (dstObj instanceof IBindingContainer) {
         IBindingContainer bc = (IBindingContainer) dstObj;
         bindings = bc.getBindings();
      }
      else {
         synchronized(bindingContainerRegistry) {
            bindings = bindingContainerRegistry.get(dstObj);
         }
      }
      if (bindings != null) {
         for (int i = 0; i < bindings.size(); i++) ct += bindings.get(i).refreshBinding();
      }
      if (refreshChildren) {
         Object[] children = DynUtil.getObjChildren(dstObj, null, false);
         if (children != null) {
            for (Object child : children) {
               if (child != null)
                  ct += refreshBindings(child, true);
            }
         }
      }
      return ct;
   }
   public static void accessBindings(Object dstObj, boolean doChildren) {
      List<DestinationListener> bindings;
      int ct = 0;
      if (dstObj instanceof IBindingContainer) {
         IBindingContainer bc = (IBindingContainer) dstObj;
         bindings = bc.getBindings();
      }
      else {
         synchronized(bindingContainerRegistry) {
            bindings = bindingContainerRegistry.get(dstObj);
         }
      }
      if (bindings != null) {
         for (int i = 0; i < bindings.size(); i++) bindings.get(i).accessBinding();
      }
      String scopeName = DynUtil.getScopeName(dstObj);
      if (scopeName != null)
         SyncManager.accessSyncInst(dstObj, scopeName);
      if (doChildren) {
         Object[] children = DynUtil.getObjChildren(dstObj, null, false);
         if (children != null) {
            for (Object child : children) {
               if (child != null)
                  accessBindings(child, true);
            }
         }
      }
   }
   public static int refreshBinding(Object dstObj, String propName) {
      DestinationListener[] bindings = getBindings(dstObj);
      if (bindings == null)
         return 0;
      int sz = bindings.length;
      int ct = 0;
      for (int i = 0; i < sz; i++) {
         DestinationListener binding = bindings[i];
         if (PBindUtil.equalProps(binding.dstProp, propName)) {
            ct += binding.refreshBinding();
         }
      }
      return ct;
   }
   public static void addDynamicListener(Object obj, Object typeObj, String propName, IListener listener, int eventMask) {
      IBeanMapper mapper = DynUtil.getPropertyMapping(typeObj, propName);
      if (mapper == null) {
         System.err.println("*** Failed to add dynamic listener.  Property: " + propName + " not found for obj: " + obj);
         return;
      }
      else
      if (mapper.getStaticPropertyPosition() != -1)
         obj = typeObj;
      addListener(obj, mapper, listener, eventMask);
   }
   public static void addDynamicListener(Object obj, String propName, IListener listener, int eventMask) {
      Object typeObj = DynUtil.getType(obj);
      addDynamicListener(obj, typeObj, propName, listener, eventMask);
   }
   public static void addListener(Object obj, Object propObj, IListener listener, int eventMask) {
      addListener(obj, propObj, listener, eventMask, 0);
   }
   public static void addListener(Object obj, Object propObj, IListener listener, int eventMask, int priority) {
      if (propObj instanceof String) {
         Object typeObj = DynUtil.isType(obj) ? obj : DynUtil.getSType(obj);
         IBeanMapper mapper = DynUtil.getPropertyMapping(typeObj, (String) propObj);
         if (mapper == null) {
            System.err.println("*** Bind.addListener failed - no property named: " + propObj + " on type: " + DynUtil.getSType(obj));
            return;
         }
         addListener(obj, mapper, listener, eventMask, 0);
      }
      else
      if (propObj instanceof IBeanMapper || propObj == null) {
         IBeanMapper prop = (IBeanMapper) propObj;
         BindingListener[] newListeners;
         if (obj instanceof IBindable) {
            IBindable bobj = (IBindable) obj;
            int propPos = prop == null ? 0 : prop.getPropertyPosition(obj);
            if (propPos == -1)
               throw new IllegalArgumentException("Attempt to bind to non-existent property: " + prop + " on: " + DynUtil.getInstanceName(obj));
            BindingListener[] oldListeners = bobj.getBindingListeners();
            if (oldListeners == null) {
               newListeners = new BindingListener[DynUtil.getPropertyCount(obj)];
               bobj.setBindingListeners(newListeners);
            }
            else
            if (oldListeners.length <= propPos) {
               newListeners = new BindingListener[DynUtil.getPropertyCount(obj)];
               System.arraycopy(oldListeners, 0, newListeners, 0, oldListeners.length);
               bobj.setBindingListeners(newListeners);
            }
            else
               newListeners = oldListeners;
            BindingListener n = new BindingListener(eventMask, listener, priority);
            BindingListener prev = null;
            BindingListener cur = newListeners[propPos];
            while (cur != null && cur.priority >= n.priority) {
               prev = cur;
               cur = cur.next;
            }
            if (prev == null) {
               n.next = newListeners[propPos];
               newListeners[propPos] = n;
            }
            else {
               n.next = prev.next;
               prev.next = n;
            }
         }
         else {
            boolean isStatic = DynUtil.isSType(obj);
            Object cl = (isStatic && prop != null ? prop.getOwnerType() : DynUtil.getType(obj));
            int propPos = prop == null ? 0 : isStatic ? prop.getStaticPropertyPosition() : prop.getPropertyPosition(obj);
            if (isStatic)
               obj = cl;
            if (propPos == -1) {
               if ((isStatic ? prop.getPropertyPosition(obj) : prop.getStaticPropertyPosition()) != -1)
                  throw new IllegalArgumentException("Attempt to bind to a " + (isStatic ? "static" : "non-static") + " property which is " + (isStatic ? "not static" : "static"));
               else
                  throw new IllegalArgumentException("Attempt to bind to non-existent property: " + prop + " on: " + cl);
            }
            BindingListener n = new BindingListener(eventMask, listener, priority);
            synchronized(bindingListenerRegistry) {
               BindingListenerEntry ble = bindingListenerRegistry.get(obj);
               if (ble == null) {
                  ble = new BindingListenerEntry();
                  ble.bindingListeners = new BindingListener[isStatic ? DynUtil.getStaticPropertyCount(cl) : DynUtil.getPropertyCount(obj)];
                  bindingListenerRegistry.put(obj, ble);
               }
               BindingListener[] oldListeners = ble.bindingListeners;
               if (oldListeners == null) {
                  newListeners = new BindingListener[isStatic ? DynUtil.getStaticPropertyCount(cl) : DynUtil.getPropertyCount(obj)];
               }
               else
               if (oldListeners.length <= propPos) {
                  newListeners = new BindingListener[isStatic ? DynUtil.getStaticPropertyCount(cl) : DynUtil.getPropertyCount(obj)];
                  System.arraycopy(oldListeners, 0, newListeners, 0, oldListeners.length);
                  ble.bindingListeners = newListeners;
               }
               else
                  newListeners = oldListeners;
               if (propPos >= newListeners.length) {
                  System.err.println("*** addListener - invalid property index!");
                  return;
               }
               BindingListener cur = newListeners[propPos];
               if (cur == null)
                  ble.numProps++;
               BindingListener prev = null;
               while (cur != null && cur.priority >= n.priority) {
                  prev = cur;
                  cur = cur.next;
               }
               if (prev == null) {
                  n.next = newListeners[propPos];
                  newListeners[propPos] = n;
               }
               else {
                  n.next = prev.next;
                  prev.next = n;
               }
            }
         }
         if (((eventMask & ~IListener.LISTENER_ADDED) != 0)) {
            BindingListener objListener = newListeners[0];
            while (objListener != null) {
               if ((objListener.eventMask & IListener.LISTENER_ADDED) != 0)
                  objListener.listener.listenerAdded(obj, propObj, listener, eventMask, priority);
               objListener = objListener.next;
            }
         }
      }
      else {
         IBinding binding = (IBinding) propObj;
         binding.addBindingListener(obj, listener, eventMask);
      }
   }
   public static void removeDynamicListener(Object obj, String propName, IListener listener, int eventMask) {
      Object typeObj = DynUtil.getType(obj);
      removeDynamicListener(obj, typeObj, propName, listener, eventMask);
   }
   public static void removeDynamicListener(Object obj, Object typeObj, String propName, IListener listener, int eventMask) {
      IBeanMapper mapper = DynUtil.getPropertyMapping(typeObj, propName);
      if (mapper == null) {
         System.err.println("*** Failed to remove dynamic listener.  Property: " + propName + " not found for obj: " + obj);
         return;
      }
      if (mapper.getStaticPropertyPosition() != -1)
         obj = typeObj;
      removeListener(obj, mapper, listener, eventMask);
   }
   public static void removeListener(Object obj, Object propObj, IListener listener, int eventMask) {
      if (propObj instanceof String) {
         removeListener(obj, DynUtil.getPropertyMapping(DynUtil.getType(obj), (String) propObj),
                 listener, eventMask);
      }
      else
      if (propObj instanceof IBeanMapper || propObj == null) {
         IBeanMapper prop = (IBeanMapper) propObj;
         if (obj instanceof IBindable) {
            IBindable bobj = (IBindable) obj;
            Class cl = bobj.getClass();
            int propPos = prop == null ? 0 : prop.getPropertyPosition(obj);
            if (propPos == -1)
               throw new IllegalArgumentException("Attempt to remove listener from non-existent property: " + prop + " on type: " + cl);
            BindingListener[] oldListeners = bobj.getBindingListeners();
            if (propPos >= oldListeners.length)
               throw new IllegalArgumentException("Attempt to remove listener not added for property: " + prop + " on type: " + cl);
            removeListenerFromList(obj, null, oldListeners, propPos, listener, eventMask, prop);
         }
         else {
            boolean isStatic = DynUtil.isType(obj);
            Object cl = (isStatic && prop != null ? prop.getOwnerType() : DynUtil.getType(obj));
            int propPos = prop == null ? 0 : isStatic ? prop.getStaticPropertyPosition() : prop.getPropertyPosition(obj);
            if (propPos == -1)
               throw new IllegalArgumentException("Attempt to bind to non-existent static property: " + prop + " on type: " + cl);
            if (isStatic)
               obj = cl;
            synchronized(bindingListenerRegistry) {
               BindingListenerEntry ble = bindingListenerRegistry.get(obj);
               BindingListener[] oldListeners = ble == null ? null : ble.bindingListeners;
               if (oldListeners == null || propPos >= oldListeners.length) {
                  System.out.println("Attempt to remove listener not added for property: " + prop + " on object: " + obj);
               }
               else {
                  removeListenerFromList(obj, ble, oldListeners, propPos, listener, eventMask, prop);
               }
            }
         }
      }
      else {
         IBinding binding = (IBinding) propObj;
         binding.removeBindingListener(obj, listener, eventMask);
      }
   }
   private static void removeListenerFromList(Object cl, BindingListenerEntry ble, BindingListener[] oldListeners, int propPos, IListener listener, int eventMask, IBeanMapper prop) {
      synchronized(bindingListenerRegistry) {
         BindingListener b = oldListeners[propPos];
         BindingListener p = null;
         while (b != null && (b.listener != listener || b.eventMask != eventMask)) {
            p = b;
            b = b.next;
         }
         if (b == null)
            System.err.println("Attempt to remove listener not added property: " + prop + " on: " + DynUtil.getInstanceName(cl));
         else {
            if (p == null) {
               oldListeners[propPos] = b.next;
               if (b.next == null) {
                  if (ble != null && --ble.numProps == 0)
                     bindingListenerRegistry.remove(cl);
               }
            }
            else
               p.next = b.next;
         }
      }
   }
   public static BindingListener[] getBindingListeners(Object obj) {
      if (obj instanceof IBindable) {
         IBindable bobj = (IBindable) obj;
         return bobj.getBindingListeners();
      }
      else {
         synchronized(bindingListenerRegistry) {
            BindingListenerEntry ent = bindingListenerRegistry.get(obj);
            return ent == null ? null : ent.bindingListeners;
         }
      }
   }
   public static Object NO_VALUE_EVENT_DETAIL = new String("<noValueInEventSentinel>");
   public static void sendDynamicEvent(int event, Object obj, String propName) {
      sendEvent(event, obj, DynUtil.getPropertyMapping(DynUtil.getType(obj), propName),
              NO_VALUE_EVENT_DETAIL);
   }
   public static void sendChangedEvent(Object obj, String propName) {
      sendEvent(IListener.VALUE_CHANGED, obj,
              propName == null ? null : DynUtil.getPropertyMapping(DynUtil.getType(obj), propName),
              NO_VALUE_EVENT_DETAIL);
   }
   public static void sendChange(Object obj, String propName, Object val) {
      sendEvent(IListener.VALUE_CHANGED, obj,
              propName == null ? null : DynUtil.getPropertyMapping(DynUtil.getType(obj), propName),
              val);
   }
   public static void sendInvalidate(Object obj, String propName, Object val) {
      sendEvent(IListener.VALUE_INVALIDATED, obj,
              propName == null ? null : DynUtil.getPropertyMapping(DynUtil.getType(obj), propName),
              val);
   }
   public static void sendValidate(Object obj, String propName, Object val) {
      sendEvent(IListener.VALUE_VALIDATED, obj,
              propName == null ? null : DynUtil.getPropertyMapping(DynUtil.getType(obj), propName),
              val);
   }
   public static void sendChange(Object obj, IBeanMapper prop, Object val) {
      sendEvent(IListener.VALUE_CHANGED, obj, prop, val);
   }
   public static void sendEvent(int event, Object obj, Object prop) {
      if (prop instanceof String)
         sendEvent(event, obj, DynUtil.getPropertyMapping(DynUtil.getType(obj), (String) prop));
      else
         sendEvent(event, obj, (IBeanMapper) prop, NO_VALUE_EVENT_DETAIL);
   }
   public static void sendCompiledChangedEvent(Object obj, IBeanMapper prop) {
      sendEvent(IListener.VALUE_CHANGED, obj, prop, NO_VALUE_EVENT_DETAIL);
   }
   private static class ThreadLogState {
      int indentLevel;
      Object obj;
      IBeanMapper prop;
      IBinding binding;
      ThreadLogState prev;
      Object val;
   }
   public static class BindFrame {
      Object obj;
      IBeanMapper prop;
      IListener listener;
      public boolean equals(Object other) {
         if (other instanceof BindFrame) {
            BindFrame o = (BindFrame) other;
            return o.obj == obj && o.prop == prop && o.listener == listener;
         }
         return false;
      }
      public int hashCode() {
         return obj.hashCode() + (prop == null ? 0 : prop.hashCode()) + listener.hashCode();
      }
      public String toString() {
         return DynUtil.getInstanceName(obj) + (prop == null ? "<default event>" : "." + prop) + " listener: " + listener;
      }
   }
   private static class ThreadState {
      int nestedLevel;
      Object obj;
      IBeanMapper prop;
      ArrayList<BindFrame> recurseFrames;
   }
   public static int getIndentLevel() {
      ThreadLogState logState = (ThreadLogState) PTypeUtil.getThreadLocal("logState");
      if (logState == null)
         return 0;
      return logState.indentLevel;
   }
   public static boolean logBindingMessage(String prefix, IBinding binding, Object obj, Object val, Object src) {
      if (val == NO_VALUE_EVENT_DETAIL) {
         val = null;
      }
      ThreadLogState logState = (ThreadLogState) PTypeUtil.getThreadLocal("logState");
      if (logState == null || logState.obj != obj || logState.binding != binding || !DynUtil.equalObjects(logState.val, val)) {
         int indentLevel = getIndentLevel();
         String bstr = binding instanceof DestinationListener ? ((DestinationListener) binding).toString(prefix, false) : binding.toString();
         if (src != null)
            bstr = src.toString() + " " + bstr;
         if (val == null)
            System.out.println(indent(indentLevel) + bstr);
         else {
            System.out.println(indent(indentLevel) + bstr + " = " + DynUtil.getInstanceName(val));
         }
         ThreadLogState prev = logState;
         logState = new ThreadLogState();
         logState.obj = obj;
         logState.binding = binding;
         logState.prev = prev;
         logState.val = val;
         logState.indentLevel = prev == null ? 0 : prev.indentLevel + 1;
         PTypeUtil.setThreadLocal("logState", logState);
         return true;
      }
      else
         return false;
   }
   public static void logMessage(String prefix, Object obj, IBeanMapper prop, Object val) {
      boolean endIndent = false;
      try {
         endIndent = logPropMessage(prefix, obj, prop, val);
      }
      finally {
         if (endIndent)
            endPropMessage();
      }
   }
   public static boolean logPropMessage(String prefix, Object obj, IBeanMapper prop, Object val) {
      if (val == NO_VALUE_EVENT_DETAIL) {
         if (prop != null)
            val = prop.getPropertyValue(obj, true, false);
         else
            val = null;
      }
      ThreadLogState logState = (ThreadLogState) PTypeUtil.getThreadLocal("logState");
      if (logState == null || logState.obj != obj || logState.prop != prop || !DynUtil.equalObjects(logState.val, val)) {
         DestinationListener binding = getBinding(obj, prop);
         int indentLevel = logState == null ? 0 : logState.indentLevel;
         if (binding != null) {
            String bstr = binding.toString(prefix, true);
            if (binding.isValid())
               System.out.println(indent(indentLevel) + bstr);
            else {
               System.out.println(indent(indentLevel) + bstr + " = " + getPrintableValue(val, obj, prop));
            }
         }
         else
         if (prop == null) {
            System.out.println("default event for: " + DynUtil.getInstanceName(obj));
         }
         else
            System.out.println(prefix + " " + DynUtil.getInstanceName(obj) + "." + prop.getPropertyName() + " = " + getPrintableValue(val, obj, prop));
         ThreadLogState prev = logState;
         logState = new ThreadLogState();
         logState.obj = obj;
         logState.prop = prop;
         logState.prev = prev;
         logState.val = val;
         logState.indentLevel = prev == null ? 0 : prev.indentLevel + 1;
         PTypeUtil.setThreadLocal("logState", logState);
         return true;
      }
      else
         return false;
   }
   private static String getPrintableValue(Object val, Object obj, IBeanMapper prop) {
      return DynUtil.getInstanceName(val == IListener.UNSET_VALUE_SENTINEL ? prop.getPropertyValue(obj, true, false) : val);
   }
   public static void endPropMessage() {
      PTypeUtil.setThreadLocal("logState", ((ThreadLogState) PTypeUtil.getThreadLocal("logState")).prev);
   }
   public static void sendEvent(int event, Object obj, String prop, Object eventDetail) {
      sendEvent(event, obj, DynUtil.getPropertyMapping(DynUtil.getType(obj), prop), eventDetail);
   }
   public static void sendEvent(int event, Object obj, IBeanMapper prop, Object eventDetail) {
      boolean endLogIndent = false;
      try {
         BindingListener[] bindings = Bind.getBindingListeners(obj);
         if (bindings == null)
            return;
         boolean isStatic = DynUtil.isType(obj);
         int propPos = prop == null ? 0 : (isStatic ? prop.getStaticPropertyPosition() : prop.getPropertyPosition(obj));
         if (bindings.length <= propPos)
            return;
         BindingListener bl = bindings[propPos];
         if (event == IListener.VALUE_CHANGED) {
            if ((trace && (traceAll || bl != null)) || (bl != null && (bl.flags & (Bind.TRACE | Bind.VERBOSE)) != 0)) {
               endLogIndent = logPropMessage("Set", obj, prop, eventDetail);
            }
            if (bl != null) {
               dispatchListeners(bindings, propPos, IListener.VALUE_INVALIDATED, obj, prop, eventDetail);
               dispatchListeners(bindings, propPos, IListener.VALUE_VALIDATED, obj, prop, eventDetail);
            }
         }
         else {
            if ((event == IListener.VALUE_VALIDATED && trace && (traceAll || bl != null)) || (bl != null && (bl.flags & (Bind.TRACE | Bind.VERBOSE)) != 0)) {
               endLogIndent = logPropMessage("ISet", obj, prop, eventDetail);
            }
            if (bl != null)
               dispatchListeners(bindings, propPos, event, obj, prop, eventDetail);
         }
      }
      finally {
         if (endLogIndent)
            endPropMessage();
      }
   }
   private static void dispatchListeners(BindingListener[] bindings, int propPos, int event, Object obj, IBeanMapper prop, Object eventDetail) {
      BindingListener b = bindings[propPos];
      while (b != null) {
         if ((b.eventMask & event) == event) {
            IListener listener = b.listener;
            bindingManager.sendEvent(listener, event, obj, prop, eventDetail);
         }
         b = b.next;
      }
   }
   public static void sendAllEvents(int event, Object obj) {
      BindingListener[] bindings = Bind.getBindingListeners(obj);
      if (bindings == null)
         return;
      boolean isStatic = DynUtil.isType(obj);
      IBeanMapper[] mappers = isStatic ? DynUtil.getStaticProperties(obj) : DynUtil.getProperties(DynUtil.getType(obj));
      assert mappers.length == bindings.length;
      int i = 0;
      for (BindingListener b : bindings) {
         while (b != null) {
            if ((b.eventMask & event) == event) {
               IListener listener = b.listener;
               bindingManager.sendEvent(listener, event, obj, mappers[i], null);
            }
            b = b.next;
         }
         i++;
      }
   }
   private final static int RecursionDetectionThreadhold = 150;
   public static int getNestedBindingCount() {
      ThreadState bindState = (ThreadState) PTypeUtil.getThreadLocal("bindingState");
      if (bindState == null)
         return 0;
      return bindState.nestedLevel;
   }
   static void dispatchEvent(int event, Object obj, IBeanMapper prop, IListener listener, Object eventDetail, CurrentScopeContext origCtx) {
      if (listener.isCrossScope()) {
         CurrentScopeContext curScopeCtx = CurrentScopeContext.getCurrentScopeContext();
         List<CurrentScopeContext> listenerCtxs = listener.getCurrentScopeContexts();
         boolean deliverToCurrent = false;
         int ct = 0;
         for (CurrentScopeContext listenerCtx : listenerCtxs) {
            if (origCtx != null && origCtx.sameContexts(listenerCtx))
               continue;
            if (listenerCtx != curScopeCtx) {
               ScopeContext listenerEventScopeCtx = listenerCtx.getEventScopeContext();
               ScopeContext curEventScopeCtx = curScopeCtx.getEventScopeContext();
               if (listenerEventScopeCtx != null && listenerEventScopeCtx != curEventScopeCtx) {
                  BindingContext bctx = (BindingContext) listenerEventScopeCtx.eventListener;
                  if (bctx == null) {
                     synchronized(listenerEventScopeCtx.eventListenerLock) {
                        bctx = (BindingContext) listenerEventScopeCtx.eventListener;
                        if (bctx == null)
                           listenerEventScopeCtx.eventListener = bctx = new BindingContext(IListener.SyncType.IMMEDIATE);
                     }
                  }
                  if (ScopeDefinition.trace || trace)
                     System.out.println("Bind - cross scope event: " + DynUtil.getInstanceName(obj) + "." + (prop == null ? "<default-event>" : prop.getPropertyName()) + " - Queuing event from: " + curScopeCtx + " to: " + listenerEventScopeCtx + " in: " + listenerCtx);
                  bctx.queueEvent(event, obj, prop, listener, eventDetail, curScopeCtx);
                  listenerEventScopeCtx.scopeChanged();
                  ct++;
               }
               else
                  deliverToCurrent = true;
            }
            else
               deliverToCurrent = true;
         }
         if (!deliverToCurrent)
            return;
      }
      ThreadState threadState = initThreadState(obj, prop, listener);
      try {
         switch(event) {
            case IListener.VALUE_INVALIDATED:
               listener.valueInvalidated(obj, prop, eventDetail, true);
               break;
            case IListener.ARRAY_ELEMENT_INVALIDATED:
               listener.arrayElementInvalidated(obj, prop, eventDetail, true);
               break;
            case IListener.VALUE_VALIDATED:
               listener.valueValidated(obj, prop, eventDetail, true);
               break;
            case IListener.ARRAY_ELEMENT_VALIDATED:
               listener.arrayElementValidated(obj, prop, eventDetail, true);
               break;
            case IListener.VALUE_CHANGED:
               listener.valueChanged(obj, prop, eventDetail, true);
               break;
            case IListener.ARRAY_ELEMENT_CHANGED:
               listener.arrayElementChanged(obj, prop, eventDetail, true);
               break;
            case IListener.VALUE_REQUESTED:
               listener.valueRequested(obj, prop);
               break;
         }
      }
      catch(BindingLoopException exc) {
         if (threadState.nestedLevel != 1)
            throw exc;
         else {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < exc.recurseFrames.size(); i++) {
               sb.append("   " + exc.recurseFrames.get(i));
            }
            System.err.println("Loop detected in bindings for change: " + DynUtil.getInstanceName(obj) + (prop == null ? " <default event>" : "." + prop) + ": " + getBinding(obj, prop) + ": " + sb);
         }
      }
      finally {
         threadState.nestedLevel--;
      }
   }
   private static ThreadState initThreadState(Object obj, IBeanMapper prop, IListener listener) {
      ThreadState bindState = (ThreadState) PTypeUtil.getThreadLocal("bindingState");
      if (bindState == null) {
         bindState = new ThreadState();
         PTypeUtil.setThreadLocal("bindingState", bindState);
      }
      bindState.nestedLevel++;
      bindState.obj = obj;
      bindState.prop = prop;
      if (bindState.nestedLevel >= RecursionDetectionThreadhold) {
         if (bindState.recurseFrames == null)
            bindState.recurseFrames = new ArrayList<BindFrame>();
         BindFrame bf = new BindFrame();
         bf.obj = obj;
         bf.prop = prop;
         bf.listener = listener;
         if (bindState.recurseFrames.contains(bf) || bindState.recurseFrames.size() > 100) {
            throw new BindingLoopException(bindState.recurseFrames);
         }
         bindState.recurseFrames.add(bf);
      }
      return bindState;
   }
   public static Class getClassForInstance(Object dstObj) {
      if (dstObj instanceof Class)
         return(Class) dstObj;
      else
         return dstObj.getClass();
   }
   public static DestinationListener getBinding(Object obj, String prop) {
      return getBinding(obj, TypeUtil.getObjectPropertyMapping(obj, prop));
   }
   public static DestinationListener getBinding(Object dstObj, IBinding dstProp) {
      List<DestinationListener> bindings;
      DestinationListener toRet = null;
      synchronized(bindingContainerRegistry) {
         if (dstObj instanceof IBindingContainer) {
            IBindingContainer bc = (IBindingContainer) dstObj;
            bindings = bc.getBindings();
         }
         else {
            bindings = bindingContainerRegistry.get(dstObj);
         }
         if (bindings == null)
            return null;
         int sz = bindings.size();
         int i;
         for (i = 0; i < sz; i++) {
            DestinationListener binding = bindings.get(i);
            if (PBindUtil.equalProps(binding.dstProp, dstProp)) {
               if (binding.direction.doForward())
                  return binding;
               else
                  toRet = binding;
            }
         }
      }
      return toRet;
   }
   public static boolean hasBindingListeners(Object obj, String prop) {
      return hasBindingListeners(obj, TypeUtil.getObjectPropertyMapping(obj, prop));
   }
   public static boolean hasBindingListeners(Object obj, IBeanMapper prop) {
      BindingListener[] listeners = getBindingListeners(obj);
      if (listeners == null)
         return false;
      int propPos = prop == null ? 0 : DynUtil.isSType(obj) ? prop.getStaticPropertyPosition() : prop.getPropertyPosition(obj);
      if (propPos == -1 || propPos > listeners.length)
         return false;
      return listeners[propPos] != null;
   }
   public static BindingListener getPropListeners(Object obj, IBeanMapper prop) {
      BindingListener[] list = getBindingListeners(obj);
      if (list == null)
         return null;
      return getPropListeners(obj, list, prop);
   }
   public static BindingListener getPropListeners(Object obj, BindingListener[] listeners, IBeanMapper prop) {
      int propPos = prop == null ? 0 : DynUtil.isSType(obj) ? prop.getStaticPropertyPosition() : prop.getPropertyPosition(obj);
      if (propPos == -1 || propPos > listeners.length)
         return null;
      return listeners[propPos];
   }
   public static DestinationListener[] getBindings(Object dstObj) {
      List<DestinationListener> bindings;
      synchronized(bindingContainerRegistry) {
         if (dstObj instanceof IBindingContainer) {
            IBindingContainer bc = (IBindingContainer) dstObj;
            bindings = bc.getBindings();
         }
         else {
            bindings = bindingContainerRegistry.get(dstObj);
         }
         if (bindings == null)
            return null;
         return bindings.toArray(new DestinationListener[bindings.size()]);
      }
   }
   public static String destinationListenerArrayToString(Object theObj, DestinationListener[] bindingListeners) {
      StringBuilder sb = new StringBuilder();
      if (bindingListeners == null || bindingListeners.length == 0)
         return "";
      else {
         for (DestinationListener dl : bindingListeners) {
            sb.append("   ");
            sb.append(dl);
            sb.append("\n");
         }
      }
      return sb.toString();
   }
   public static String listenerArrayToString(Object theObj, BindingListener[] bindingListeners) {
      if (bindingListeners == null)
         return "";
      boolean isStatic = DynUtil.isType(theObj);
      Object theClass = isStatic ? theObj : DynUtil.getType(theObj);
      IBeanMapper[] props = isStatic ? DynUtil.getStaticProperties(theClass) : DynUtil.getProperties(theClass);
      if (props == null)
         return "<no properties>";
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < props.length; i++) {
         BindingListener l = i < bindingListeners.length ? bindingListeners[i] : null;
         if (l != null) {
            IBeanMapper prop = props[i];
            if (prop == null)
               sb.append("<valueListener>");
            else
               sb.append(prop.getPropertyName());
            sb.append(":");
            sb.append("\n");
            while (l != null) {
               sb.append("   ");
               IListener rootListener = getRootListener(l.listener);
               sb.append(rootListener);
               sb.append("\n");
               l = l.next;
            }
         }
      }
      return sb.toString();
   }
   private static IListener getRootListener(IListener l) {
      if (l instanceof DestinationListener) {
         DestinationListener dl = (DestinationListener) l;
         if (dl.dstObj == dl.dstProp && dl.dstObj instanceof IListener)
            return getRootListener((IListener) dl.dstObj);
      }
      return l;
   }
   public static void printBindings(Object obj) {
      Object cl;
      cl = DynUtil.getType(obj);
      if (obj != cl) {
         String objName = DynUtil.getInstanceName(obj);
         System.out.println("Bindings for instance: " + objName);
         System.out.println("  -- from properties: ");
         System.out.println(Bind.destinationListenerArrayToString(obj, getBindings(obj)));
         System.out.println("  -- to properties: ");
         System.out.println(Bind.listenerArrayToString(obj, Bind.getBindingListeners(obj)));
      }
      String typeName = DynUtil.getTypeName(cl, false);
      System.out.println("Bindings for type: " + typeName);
      System.out.println("  -- from this type (static properties): ");
      System.out.println(Bind.destinationListenerArrayToString(cl, getBindings(cl)));
      System.out.println("  -- to this type (static properties): ");
      System.out.println(Bind.listenerArrayToString(cl, Bind.getBindingListeners(cl)));
      System.out.println("");
   }
   public static void printAllBindings() {
      synchronized(bindingContainerRegistry) {
         System.out.println("Printing all bindings:");
         for (Map.Entry<Object, List<DestinationListener>> ent : bindingContainerRegistry.entrySet()) {
            Object obj = ent.getKey();
            printBindings(obj);
         }
         System.out.println("");
      }
   }
   public static String indent(int n) {
      if (n == 0)
         return "";
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < n; i++) sb.append("   ");
      return sb.toString();
   }
   public static String arrayToString(Object[] list) {
      if (list == null)
         return "";
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < list.length; i++) {
         if (i != 0)
            sb.append(", ");
         sb.append(list[i]);
      }
      return sb.toString();
   }
   public static void setBindingParent(Object prop, IBinding parent, BindingDirection dir) {
      if (prop instanceof String)
         return;
      if (prop instanceof IBinding)
         ((IBinding) prop).setBindingParent(parent, dir);
   }
   public static void activate(Object prop, boolean state, Object bindingParent, boolean chained) {
      if (prop instanceof IBinding)
         ((IBinding) prop).activate(state, bindingParent, chained);
   }
   public static void applyReverseBinding(Object obj, Object prop, Object value, Object src) {
      if (prop instanceof IBinding)
         ((IBinding) prop).applyReverseBinding(obj, value, src);
      else
      if (obj != null)
         DynUtil.setPropertyValue(obj, (String) prop, value);
   }
   public static void applyBinding(Object obj, Object prop, Object value, IBinding src) {
      if (prop instanceof IBinding)
         ((IBinding) prop).applyBinding(obj, value, src, false, false);
      else
         DynUtil.setPropertyValue(obj, (String) prop, value);
   }
   public static void parentBindingChanged(Object prop) {
      if (prop instanceof IBinding)
         ((IBinding) prop).parentBindingChanged();
   }
}
